
//Digori Gheorghe 2018
//-------SETINGS---------
#define coin_amount 2    // numarul de monede(diferite) care trebuiesc indetificate
float coin_value[coin_amount] = {5, 10};  // valoarea monedelor
String currency = "LEI"; // valuta
int stb_time = 15000;    // timpul dupa care sistemul se duce in starea de somn
//-------setings---------

int coin_signal[coin_amount];    // vectorul de valori de semnal pentru fiecare moneda
int coin_quantity[coin_amount];  // cantitatea de monede
int empty_signal;               // nivelul semnalului gol
unsigned long standby_timer, reset_timer; // taimerele
float summ_money = 0;            // suma in pusculita

//-------biblioteci---------
#include "LowPower.h"
#include "EEPROMex.h"
#include "LCD_1602_RUS.h"
//-------biblioteci---------

LCD_1602_RUS lcd(0x3f, 16, 2);            // creare display
// daca displaiul nu functioneaza cu 0x3f se va folosi valoarea 0x27

boolean recogn_flag, sleep_flag = true;   // flags
//-------butoane---------
#define button 2         // butonul "trezire"
#define calibr_button 3  // buton de settings
#define disp_power 12    // alimentare display
#define LEDpin 11        // alimentare led
#define IRpin 17         // alimentare fotorezistenta
#define IRsens 14        // semnal fototranzistor
//-------butoane---------
int sens_signal, last_sens_signal;
boolean coin_flag = false;

void setup() {
  Serial.begin(9600);                   // deschidere port pentru conexiunea cu PC-ul pentru amanare
  delay(500);

  // pregatire butoane
  pinMode(button, INPUT_PULLUP);
  pinMode(calibr_button, INPUT_PULLUP);

  // pini curent ca iesire
  pinMode(disp_power, OUTPUT);
  pinMode(LEDpin, OUTPUT);
  pinMode(IRpin, OUTPUT);

  // trimite curent pentru display, senzor si led
  digitalWrite(disp_power, 1);
  digitalWrite(LEDpin, 1);
  digitalWrite(IRpin, 1);

  // activare intrerupere
  attachInterrupt(0, wake_up, CHANGE);
  delay(500);
  empty_signal = analogRead(IRsens);  // citire semnal gol de la fotorezist.


  // initializare display
  lcd.init();
  lcd.backlight();
  
  if (!digitalRead(calibr_button)) {  // daca la initializare se apasa si butonul de calibrare
    lcd.clear();
    lcd.setCursor(3, 0);
    lcd.print(L"Setari");
    delay(500);
    reset_timer = millis();
    while (1) {                                   // ciclu infinit
      if (millis() - reset_timer > 3000) {        // daca butonul de calibrare se tine apasat mai mult de 3 secunde
        // se reseteaza contoarele de monede
        for (byte i = 0; i < coin_amount; i++) {
          coin_quantity[i] = 0;
          EEPROM.writeInt(20 + i * 2, 0);
        }
        lcd.clear();
        lcd.setCursor(0, 0);
        lcd.print(L"Memorie stearsa");
        delay(100);
      }
      if (digitalRead(calibr_button)) {   // daca sa lasat butonul de setare se intra in meiul de calibrare
        lcd.clear();
        lcd.setCursor(0, 0);
        lcd.print(L"Calibrare");
        break;
      }
    }
    while (1) {
      for (byte i = 0; i < coin_amount; i++) {
        //lcd.setCursor(0, 1); lcd.print(coin_value[i]);  // se afiseaza valoarea monedei a carei dimensiune se inregistreaza la moment
        //lcd.setCursor(13, 1); lcd.print(currency);      // afisare valuta
        last_sens_signal = empty_signal;
        while (1) {
          sens_signal = analogRead(IRsens);                                    // citire date de la senzor(fototranzistor)
          if (sens_signal > last_sens_signal) last_sens_signal = sens_signal;

           lcd.setCursor(0, 0); lcd.print(empty_signal);
           lcd.setCursor(6, 1); lcd.print(sens_signal);
           lcd.setCursor(13, 1); lcd.print(last_sens_signal);
           // daca valoarea curenta e mai mare decat valoarea precedenta
          if (sens_signal - empty_signal > 20) coin_flag = true;
          // daca valoare tensiunii a scazut la valoarea goala se considera ca moneda a trecut
          if (coin_flag && (abs(sens_signal - empty_signal)) < 500) {            // daca moneda sigur a trecut
            coin_signal[i] = last_sens_signal;
            lcd.clear();
            lcd.setCursor(0, 0);
            lcd.print(coin_signal[i]);
            delay(2000);
            // se scrie valoarea maxima in memorie
            EEPROM.writeInt(i * 2, coin_signal[i]);
            coin_flag = false;
            break;
          }
        }
      }
      break;
    }
  }

  // la pornire se citesc din memorie semnalele(tensiunile) monedelor pentru lucru ulterior cu ele, deasemenea numarul lor
  for (byte i = 0; i < coin_amount; i++) {
    coin_signal[i] = EEPROM.readInt(i * 2);
    coin_quantity[i] = EEPROM.readInt(20 + i * 2);
    summ_money += coin_quantity[i] * coin_value[i];  // suma se citeste ca produs de valoare si numar de monede
  }

  
 /*   // afisare semnal monede
    for (byte i = 0; i < coin_amount; i++) {
      Serial.println(coin_signal[i]);
    }
  */
  standby_timer = millis();  // resetare timer pentru intrarea in starea de somn
}

void loop() {
  if (sleep_flag) {  // daca sa iesit din starea de somn se aprinde displaiul si afiseaza textul, suma si valuta
    delay(500);
    lcd.init();
    lcd.clear();
    lcd.setCursor(0, 0); lcd.print(L"PENTRU MASINA");
    lcd.setCursor(0, 1); lcd.print(summ_money);
    lcd.setCursor(13, 1); lcd.print(currency);
    empty_signal = analogRead(IRsens);
    sleep_flag = false;
  }

last_sens_signal = empty_signal;
  while (1) {
    sens_signal = analogRead(IRsens);  // mai departe acelasi algoritm ca si la calibrare
    if (sens_signal > last_sens_signal) last_sens_signal = sens_signal;
    //lcd.setCursor(0, 0); lcd.print(last_sens_signal);

    if (sens_signal - empty_signal > 30) coin_flag = true;
    if (coin_flag && (abs(sens_signal - empty_signal)) < 250) {
      recogn_flag = false;  // flags de eroare nefolosit momentan
      // cand sa gasit valoarea maxima pentru o moneda care a trecut, l-am salvat last_sens_signal
      // comapram valoarea salvata cu valorile pentru monede salvate in memorie
      for (byte i = 0; i < coin_amount; i++) {
        int delta = abs(last_sens_signal - coin_signal[i]);   // cel ami important, se cauta o valoare de eroare
        // diferenta dintre valoarea semnalului curent si semnalele salvate in memorie pentru monede
          //lcd.setCursor(0, 0); lcd.print(delta);

        if (delta < 6) {   // daca delta diferentei corespunde unui interval, consideram moneda ca fiind recunoscuta
          summ_money += coin_value[i];  // se adauga valoarea mondei care tocmai a trecut la suma totala de monede aflate in psuculita
          lcd.setCursor(0, 1); lcd.print(summ_money);
          coin_quantity[i]++;  // incrementam suma de tip de moneda pentru tipul de moneda curent
          recogn_flag = true;
          delay(500);
          break;
        }
      }
      /*
        if ((last_sens_signal > coin_signal[0] - 2) || (last_sens_signal < coin_signal[0] + 2)) {   // daca delta diferentei corespunde unui interval, consideram moneda ca fiind recunoscuta
          summ_money += coin_value[0];  // se adauga valoarea mondei care tocmai a trecut la suma totala de monede aflate in psuculita
          lcd.setCursor(0, 1); lcd.print(summ_money);
          coin_quantity[i]++;  // incrementam suma de tip de moneda pentru tipul de moneda curent
          recogn_flag = true;
          break;
        }
        else if ((last_sens_signal > coin_signal[1] - 2) || (last_sens_signal < coin_signal[1] + 2)) {   // daca delta diferentei corespunde unui interval, consideram moneda ca fiind recunoscuta
          summ_money += coin_value[1];  // se adauga valoarea mondei care tocmai a trecut la suma totala de monede aflate in psuculita
          lcd.setCursor(0, 1); lcd.print(summ_money);
          coin_quantity[i]++;  // incrementam suma de tip de moneda pentru tipul de moneda curent
          recogn_flag = true;
          break;
        }
      }
      */
      coin_flag = false;
      standby_timer = millis();  // se reseteaza timerul
      break;
    }
    // daca nu sa intamplat nimic timp de 15 secunde se intra in starea de somn(displaiul)
    if (millis() - standby_timer > stb_time) {
      good_night();
      break;
    }

    // daca butonul de settings si trezire sunt apsata simultan timp de 2 sec se intra in meniul tipului de monede
    while (!digitalRead(button)) {
      if (millis() - standby_timer > 2000) {
        lcd.clear();

        // se afiseaza pe display tipul monedelor si mai jos numarul de monede de acel tip
        for (byte i = 0; i < coin_amount; i++) {
          lcd.setCursor(i * 3, 0); lcd.print((int)coin_value[i]);
          lcd.setCursor(i * 3, 1); lcd.print(coin_signal[i]);
        }
      }
    }
  }
}

// functia de somn
void good_night() {
  // inainte de a merge la somn se salveaza in EEPROM noua cantitate de monede incepand cu 20
  for (byte i = 0; i < coin_amount; i++) {
    EEPROM.updateInt(20 + i * 2, coin_quantity[i]);
  }
  sleep_flag = true;
  // intrerupem curentul pentru senzori si display(pentru ergonomie)
  digitalWrite(disp_power, 0);
  digitalWrite(LEDpin, 0);
  digitalWrite(IRpin, 0);
  delay(100);
  // go to sleep
  LowPower.powerDown(SLEEP_FOREVER, ADC_OFF, BOD_OFF);
}

// trezire la apasarea butonului de trezire
void wake_up() {
  // se readuce curentul pe senzori si display
  digitalWrite(disp_power, 1);
  digitalWrite(LEDpin, 1);
  digitalWrite(IRpin, 1);
  standby_timer = millis();  // resetare timer
}
